+(function() {
    var options = {
        pullDownArrowIcon: '#arrowIcon',
        pullDownDragClass: 'down',
        pullDownReleaseClass: 'up',
        pullDownSpinnerIcon: '.spinner',
        pullDownTextContainer: '#pullText',
        pullDownPullNotice: '下拉刷新',
        pullDownReleaseNotice: '释放加载',
        pullDownLoadingNotice: '正在加载',
        pullDownFinishNotice: '正在加载',
        pullUpLoadingNotice: '刷新成功',
        pullUpLoadingContainer: '.upfont',
        dragThreshold: 0.3, // 临界值
        moveCount: 200 // 位移系数
    }

    var dragStart = null; // 开始抓取标志位
    var percentage = 0; // 拖动量的百分比
    var joinRefreshFlag = null; // 进入下拉刷新状态标志位
    var refreshFlag = 0; // 下拉刷新执行是控制页面假死标志位
    var changeOneTimeFlag = 0; // 修改dom只执行1次标志位
    var pullIcon = null; // 下拉loading
    var pullText = null; // 下拉文字dom
    var pullArrow = null; // 下拉箭头dom
    var listContainer = null;

    var screenWidth = document.documentElement.clientWidth; //可视区域宽度
    var docClientHeight = null; //document.body.clientHeight;	//文档可视区域的高度

    var xx, yy, XX, YY, swipeX, swipeY;

    function moveStart(event) {
        if (refreshFlag) {
            event.stopPropagation(); //阻止冒泡
            event.preventDefault(); //阻止浏览器默认事件
            return;
        }

        dragStart = event.touches[0].clientY;
        if(pullIcon){
            pullIcon.style.display = 'none';
        }
        if(pullArrow){
            pullArrow.className = '';
        }
        xx = event.targetTouches[0].screenX;
        yy = event.targetTouches[0].screenY;
        swipeX = true;
        swipeY = true;
    }

    //监测并控制顶部加载提示
    function moving(event) {
        if (dragStart === null) {
            return;
        }
        if (refreshFlag) {
            event.stopPropagation(); //阻止冒泡
            event.preventDefault(); //阻止浏览器默认事件
            return;
        }

        XX = event.targetTouches[0].screenX;
        YY = event.targetTouches[0].screenY;

        if (swipeX && Math.abs(XX - xx) - Math.abs(YY - yy) > 0) { //左右滑动
            // event.stopPropagation(); //阻止冒泡
            // event.preventDefault(); //阻止浏览器默认事件
            // swipeY = false;
            // //左右滑动
            // console.log('左右滑动');
            // options.onSwipe && options.onSwipe();
        } else if (swipeY && Math.abs(XX - xx) - Math.abs(YY - yy) < 0) { //上下滑动
            swipeX = false;
            //上下滑动，使用浏览器默认的上下滑动

            // 当且紧当scrolltop是0且往下滚动时才触发
            if (document.body.scrollTop == 0) {
                var target = event.touches[0];
                percentage = (dragStart - target.clientY) / window.screen.height;
                if (percentage < 0) {
                    event.preventDefault();
                    if (!changeOneTimeFlag) {
                        pullArrow.style.display = 'inline-block';
                        listContainer.style.transitionDuration = "1ms";
                        options.beforePull && options.beforePull();
                        changeOneTimeFlag = 1;
                    }
                    var translateX = -percentage * options.moveCount;
                    joinRefreshFlag = true;
                    if (Math.abs(percentage) > options.dragThreshold) {
                        _pullDownLoadingNotice('release');
                    } else {
                        _pullDownLoadingNotice('down');
                    }
                    listContainer.style.WebkitTransform = 'translate3d(0,' + translateX + 'px,0)';
                    return true;
                }
            }
        }
        joinRefreshFlag = joinRefreshFlag == null ? false : joinRefreshFlag;
    }

    //监测并控制顶部加载
    function moveStop(event) {
        if (percentage === 0) {
            return;
        }
        if (refreshFlag) {
            event.stopPropagation(); //阻止冒泡
            event.preventDefault(); //阻止浏览器默认事件
            return;
        }
        if (Math.abs(percentage) > options.dragThreshold && joinRefreshFlag) {
            options.onRefresh && options.onRefresh();
            listContainer.style.WebkitTransform = '330ms';
            _pullDownLoadingNotice('loading');
            listContainer.style.WebkitTransform = 'translate3d(0,' + 43 + 'px,0)';
            // 进入下拉刷新状态
            refreshFlag = 1;
            //加载数据
            setTimeout(function() {
                _pullDownLoadingNotice('hide');
                listContainer.style.WebkitTransform = 'translate3d(0,0,0)';
                setTimeout(function() {
                    options.afterPull && options.afterPull();
                    // 重置标志位
                    refreshFlag = 0;
                }, 300);
            }, 700);
        } else {
            if (joinRefreshFlag) {
                refreshFlag = 1;
                listContainer.style.WebkitTransform = '330ms';
                listContainer.style.WebkitTransform = 'translate3d(0,0,0)';
                setTimeout(function() {
                    options.afterPull && options.afterPull();
                    // 重置标志位
                    refreshFlag = 0;
                }, 300);
            }
        }
        // 重置changeOneTimeFlag
        changeOneTimeFlag = 0;
        // 重置joinRefreshFlag
        joinRefreshFlag = null;
        // 重置percentage
        dragStart = null;
        // 重置percentage
        percentage = 0;
    }

    function _pullUpLoadingNotice(showOrHide) {
        if (showOrHide == 'show') {
            if (options.onLoadMore) {
                // document.querySelector(options.pullUpLoadingContainer).innerHTML = options.pullUpLoadingNotice;
            }
            document.querySelector(options.pullUpLoadingContainer).style.display = "block";
        } else {
            document.querySelector(options.pullUpLoadingContainer).style.display = "none";
        }
    }

    /**
     * 下拉刷新提示
     * @param type down/release/loading/hide
     * @private
     */
    function _pullDownLoadingNotice(type) {
        if (type == 'release') { //顶部是否到达触发点
            pullText.innerHTML = options.pullDownReleaseNotice;
            pullArrow.className = options.pullDownReleaseClass;
        } else if (type == 'down') {
            pullText.innerHTML = options.pullDownPullNotice;
            pullArrow.className = options.pullDownDragClass;
        } else if (type == 'loading') {
            pullText.innerHTML = options.pullDownLoadingNotice;
            pullIcon.style.display = 'inline-block';
            pullArrow.style.display = 'none';
        } else {
            pullText.innerHTML = options.pullUpLoadingNotice;
            pullIcon.style.display = 'none';
        }
    }

    //监测并控制底部加载
    function _onbodyScroll() {
        var preLoadDis = '0';
        var offsetHeight = window.innerHeight,
            scrollHeight = document.body.scrollHeight,
            scrollTop = document.body.scrollTop;
        if (parseInt(preLoadDis) != preLoadDis) { // 如果是小数 则为百分比距离
            preLoadDis = scrollHeight * preLoadDis;
        }

        if ((scrollTop + offsetHeight) >= scrollHeight - preLoadDis) {
            _pullUpLoadingNotice("show");
            //控制底部加载
            options.onLoadMore && options.onLoadMore('1');
            loading = true;
        }
    }
    var Uiop = {
        init: function(opts) {
            if (!opts) {
                return options;
            }
            for (var key in opts) {
                options[key] = opts[key];
            }
            return this;
        },
        listen: function(elem) {
            if (typeof elem === 'string') {
                listContainer = document.querySelector(elem);
                pullIcon = document.querySelector(options.pullDownSpinnerIcon); // 下拉loading
                pullText = document.querySelector(options.pullDownTextContainer); // 下拉文字dom
                pullArrow = document.querySelector(options.pullDownArrowIcon); // 下拉箭头dom
                if (listContainer == null) {
                    console.log('list element not found!');
                    return;
                }
                docClientHeight = document.body.clientHeight;
                //绑定触摸的事件
                var pushdrop = document.querySelector('body');
                if (pushdrop.addEventListener) {
                    //所有主流浏览器，除了 IE 8 及更早 IE版本
                    pushdrop.addEventListener("touchstart", moveStart);
                    pushdrop.addEventListener('touchmove', moving, false);
                    pushdrop.addEventListener('touchend', moveStop, false);
                    window.addEventListener('scroll', _onbodyScroll, false);
                } else if (pushdrop.attachEvent) {
                    // IE 8 及更早 IE 版本
                    pushdrop.attachEvent("touchstart", moveStart);
                    pushdrop.attachEvent('touchmove', moving, false);
                    pushdrop.attachEvent('touchend', moveStop, false);
                    window.attachEvent('scroll', _onbodyScroll, false);
                }
            }
        },
        //完成下拉刷新
        finishDownLoading: function() {
            listContainer.style.transitionDuration = "1ms";
            listContainer.style.webkitTransform = 'translate3d(0,0,0)';

            _pullDownLoadingNotice('hide');
            loading = false;
        },
        //完成上拉加载更多
        finishUpLoading: function() {
            _pullUpLoadingNotice('hide');
            loading = false;
        }
    }
    window['Uiop'] = Uiop;
}())