+(function() {
    var MaConst = {
        'env': 'pro',
        'version': '1.0',
        'hosts': {
            'dev': '221.122.73.187:8080',
            'pro': 'r.newssdk.com'
        },
        'conf': {
            'http': {},
            'https': {}
        }
    };

    var lineInfo = Databinder.getLineInfo(); //行高等信息
    Databinder.extend({
        MaConst: MaConst,
        //设置每行显示内容
        setRowData: function(row, item, timeFormatFn) {
            var patch_time = row.data()['rec_time'];
            row.attr('patch_time',patch_time);
            row.attr('rectime',item['tm']);
            row.find('.news_title').html(item['tt']);
            if(item['is_clk'] == 1){
                row.find('.news_title').attr('style','color: #999;');
            }
            row.find('[data-original]').each(function(index, el) {
                $(this).attr('data-original', item['img'][index]);
                $(this).css('background-image', "url(" + item['img'][index] + ")");
                $(this).css('height', lineInfo.oneImgHeigth);
            });
            row.find('.set_img_height').each(function(index, el) {
                $(this).css('height', lineInfo.oneImgHeigth + 'px');
            });
            row.find('.set_line_height').each(function(index, el) {
                $(this).css('line-height', lineInfo.lineHeight + 'px');
            });
            row.find('.set_max_height').each(function(index, el) {
                // $(this).css('max-height', maxHeight+'px');
                $(this).css('max-height', (lineInfo.oneImgHeigth - 9) + 'px');
            });
            row.find('.mp').each(function(index, el) {
                var mp = ''
                if (typeof(item['s']) != "undefined" && item['s'].trim() != "") {
                    if(item['isTop']){
                        mp = item['s']; //置顶内容不显示时间
                    }else{
                        if(item['tm']){
                            mp = '<span>'+item['s']+'</span>' + ' | ' + '<span class="rectime">'+timeFormatFn(item['tm'])+'</span>';
                        }else{
                            mp = item['s']; //时间显示不正确时不显示时间
                        }
                    }
                } else {
                    mp = '<span class="rectime">'+timeFormatFn(item['tm'])+'</span>';
                }
                $(this).html(mp);
            });
        },
        setUrl: function(oneRow, appSpotInfo, constcfg, req_url_pre, localmode) {
            var p = Databinder.buildParams(this.requestParams['itembase'], appSpotInfo);
            oneRow.data('url', req_url_pre + constcfg['itembase'] + '?' + p);
            Databinder.isInApp(function(inApp) {
                if(localmode){
                    oneRow.data('url', '?' + p);
                }else{
                    oneRow.data('url', req_url_pre + constcfg['itembase'] + '?' + p);
                }
            });
        },
        requestParams: {
            list: { 's': '', 'q': '', 'i': '', 'ak': '', 'spot': '', 'u': '', 'ns': '0', 'first': '1', 'mid': '','rec_time':'' },
            itembase: { 'i': '', 'u': '', 'mid': '', 'ak': '', 'spot': '', 'set': '','env':'','i_code':''}
        },
        requestParamsMap: { 'u': 'uuid', 'itemId': 'i' },
    }, true);
}())